---
- name: Delete the k8s access key
  delegate_to: localhost
  ansible.builtin.command: >
    infra keys remove {{ target_hosts }}-k8s --connector --force
  environment:
    INFRA_SERVER: "{{ infra_client_server_url }}"
    INFRA_ACCESS_KEY: "{{ infra_client_access_key }}"
  register: result
  failed_when: "'Removed access key' not in result.stdout and 'does not exist' not in result.stderr"
  changed_when: "'Removed access key' in result.stdout"

- name: Create the k8s access key
  delegate_to: localhost
  ansible.builtin.command: >
    infra keys add --connector --name {{ target_hosts }}-k8s -q
  environment:
    INFRA_SERVER: "{{ infra_client_server_url }}"
    INFRA_ACCESS_KEY: "{{ infra_client_access_key }}"
  register: infra_access_key_k8s
  changed_when: true

- name: Add stable chart repo
  kubernetes.core.helm_repository:
    name: infrahq
    repo_url: "https://infrahq.github.io/helm-charts"

- name: Install Infra Connector Helm Chart
  kubernetes.core.helm:
    name: "{{ infra_k8s_chart_release_name }}"
    namespace: "{{ infra_k8s_chart_namespace }}"
    create_namespace: true
    atomic: true
    chart_ref: infrahq/infra
    chart_version: "{{ infra_k8s_chart_version }}"
    wait: true
    update_repo_cache: true
    values:
      config:
        server:
          url: "{{ infra_client_server_url }}"
        name: "{{ target_hosts }}-k8s"
        accessKey: "{{ infra_access_key_k8s.stdout }}"
